xref: /linux/scripts/link-vmlinux.sh (revision 85cdaca6970028bf6f544c355c90035586836ddf)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12#   ^
13#   |
14#   +--< vmlinux.a
15#   |
16#   +--< $(KBUILD_VMLINUX_LIBS)
17#   |    +--< lib/lib.a + more
18#   |
19#   +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34VMLINUX="$4"
35
36is_enabled() {
37	grep -q "^$1=y" include/config/auto.conf
38}
39
40# Nice output in kbuild format
41# Will be suppressed by "make -s"
42info()
43{
44	printf "  %-7s %s\n" "${1}" "${2}"
45}
46
47# Link of vmlinux
48# ${1} - output file
49vmlinux_link()
50{
51	local output=${1}
52	local objs
53	local libs
54	local ld
55	local ldflags
56	local ldlibs
57
58	info LD ${output}
59
60	# skip output file argument
61	shift
62
63	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT ||
64	   is_enabled CONFIG_KLP_BUILD; then
65		# Use vmlinux.o instead of performing the slow LTO link again.
66		objs=vmlinux.o
67		libs=
68	else
69		objs=vmlinux.a
70		libs="${KBUILD_VMLINUX_LIBS}"
71	fi
72
73	if is_enabled CONFIG_GENERIC_BUILTIN_DTB; then
74		objs="${objs} .builtin-dtbs.o"
75	fi
76
77	objs="${objs} .vmlinux.export.o"
78	objs="${objs} init/version-timestamp.o"
79
80	if [ "${SRCARCH}" = "um" ]; then
81		wl=-Wl,
82		ld="${CC}"
83		ldflags="${CFLAGS_vmlinux}"
84		ldlibs="-lutil -lrt -lpthread"
85	else
86		wl=
87		ld="${LD}"
88		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
89		ldlibs=
90	fi
91
92	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
93
94	# The kallsyms linking does not need debug symbols included.
95	if [ -n "${strip_debug}" ] ; then
96		ldflags="${ldflags} ${wl}--strip-debug"
97	fi
98
99	if [ -n "${generate_map}" ];  then
100		ldflags="${ldflags} ${wl}-Map=vmlinux.map"
101	fi
102
103	${ld} ${ldflags} -o ${output}					\
104		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
105		${wl}--start-group ${libs} ${wl}--end-group		\
106		${kallsymso} ${btf_vmlinux_bin_o} ${arch_vmlinux_o} ${ldlibs}
107}
108
109# Check if kallsymso_prev and kallsymso differ
110# If symbol sizes within ${kallsymso} change, any symbols within vmlinux are
111# likely to shift, invalidating ${kallsymso}.
112# Since file size can remain unchanged even if symbol sizes change, compare the
113# actual symbols instead of relying on file size only.
114kallsymso_changed()
115{
116	${NM} -n "${kallsymso_prev}" > "${kallsymso_prev}.sym"
117	${NM} -n "${kallsymso}" > "${kallsymso}.sym"
118	! cmp -s "${kallsymso_prev}.sym" "${kallsymso}.sym"
119}
120
121# Create ${2}.o file with all symbols from the ${1} object file
122kallsyms()
123{
124	local kallsymopt;
125
126	if is_enabled CONFIG_KALLSYMS_ALL; then
127		kallsymopt="${kallsymopt} --all-symbols"
128	fi
129
130	if is_enabled CONFIG_64BIT || is_enabled CONFIG_RELOCATABLE; then
131		kallsymopt="${kallsymopt} --pc-relative"
132	fi
133
134	info KSYMS "${2}.S"
135	scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
136
137	info AS "${2}.o"
138	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
139	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
140
141	kallsymso_prev="${kallsymso:-}"
142	kallsymso=${2}.o
143}
144
145# Perform kallsyms for the given temporary vmlinux.
146sysmap_and_kallsyms()
147{
148	mksysmap "${1}" "${1}.syms"
149	kallsyms "${1}.syms" "${1}.kallsyms"
150
151	kallsyms_sysmap=${1}.syms
152}
153
154# Create map file with all symbols from ${1}
155# See mksymap for additional details
156mksysmap()
157{
158	info NM ${2}
159	${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
160}
161
162sorttable()
163{
164	${NM} -S ${1} > .tmp_vmlinux.nm-sort
165	${objtree}/scripts/sorttable -s .tmp_vmlinux.nm-sort ${1}
166}
167
168cleanup()
169{
170	rm -f .btf.*
171	rm -f .tmp_vmlinux.nm-sort
172	rm -f System.map
173	rm -f vmlinux
174	rm -f vmlinux.map
175}
176
177# Use "make V=1" to debug this script
178case "${KBUILD_VERBOSE}" in
179*1*)
180	set -x
181	;;
182esac
183
184if [ "$1" = "clean" ]; then
185	cleanup
186	exit 0
187fi
188
189${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
190
191arch_vmlinux_o=
192if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
193	arch_vmlinux_o=arch/${SRCARCH}/tools/vmlinux.arch.o
194fi
195
196btf_vmlinux_bin_o=
197btfids_vmlinux=
198kallsymso=
199strip_debug=
200generate_map=
201
202# Use "make UT=1" to trigger warnings on unused tracepoints
203case "${WARN_ON_UNUSED_TRACEPOINTS}" in
204*1*)
205	${objtree}/scripts/tracepoint-update vmlinux.o
206	;;
207esac
208
209if is_enabled CONFIG_KALLSYMS; then
210	true > .tmp_vmlinux0.syms
211	kallsyms .tmp_vmlinux0.syms .tmp_vmlinux0.kallsyms
212fi
213
214if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
215
216	# The kallsyms linking does not need debug symbols, but the BTF does.
217	if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
218		strip_debug=1
219	fi
220
221	vmlinux_link .tmp_vmlinux1
222fi
223
224if is_enabled CONFIG_DEBUG_INFO_BTF; then
225	info BTF .tmp_vmlinux1
226	if ! ${CONFIG_SHELL} ${srctree}/scripts/gen-btf.sh .tmp_vmlinux1; then
227		echo >&2 "Failed to generate BTF for vmlinux"
228		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
229		exit 1
230	fi
231	btf_vmlinux_bin_o=.tmp_vmlinux1.btf.o
232	btfids_vmlinux=.tmp_vmlinux1.BTF_ids
233fi
234
235if is_enabled CONFIG_KALLSYMS; then
236
237	# kallsyms support
238	# Generate section listing all symbols and add it into vmlinux
239	# It's a four step process:
240	# 0)  Generate a dummy __kallsyms with empty symbol list.
241	# 1)  Link .tmp_vmlinux1.kallsyms so it has all symbols and sections,
242	#     with a dummy __kallsyms.
243	#     Running kallsyms on that gives us .tmp_vmlinux1.kallsyms.o with
244	#     the right size
245	# 2)  Link .tmp_vmlinux2.kallsyms so it now has a __kallsyms section of
246	#     the right size, but due to the added section, some
247	#     addresses have shifted.
248	#     From here, we generate a correct .tmp_vmlinux2.kallsyms.o
249	# 3)  That link may have expanded the kernel image enough that
250	#     more linker branch stubs / trampolines had to be added, which
251	#     introduces new names, which further expands kallsyms. Do another
252	#     pass if that is the case. In theory it's possible this results
253	#     in even more stubs, but unlikely.
254	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
255	#     other bugs.
256	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
257	#
258	# a)  Verify that the System.map from vmlinux matches the map from
259	#     ${kallsymso}.
260
261	# The kallsyms linking does not need debug symbols included.
262	strip_debug=1
263
264	sysmap_and_kallsyms .tmp_vmlinux1
265	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
266
267	vmlinux_link .tmp_vmlinux2
268	sysmap_and_kallsyms .tmp_vmlinux2
269	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
270
271	# Due to alignment, file size of the kallsymso object file might remain
272	# unchanged even if individual symbols within change size. Changed
273	# symbol sizes can still shift other symbols, though. Therefore, don't
274	# rely on file size alone.
275	if [ $size1 -ne $size2 ] || kallsymso_changed || \
276			[ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277		vmlinux_link .tmp_vmlinux3
278		sysmap_and_kallsyms .tmp_vmlinux3
279	fi
280fi
281
282strip_debug=
283
284if is_enabled CONFIG_VMLINUX_MAP; then
285	generate_map=1
286fi
287
288vmlinux_link "${VMLINUX}"
289
290if is_enabled CONFIG_DEBUG_INFO_BTF; then
291	info BTFIDS ${VMLINUX}
292	${RESOLVE_BTFIDS} --patch_btfids ${btfids_vmlinux} ${VMLINUX}
293fi
294
295mksysmap "${VMLINUX}" System.map
296
297if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
298	info SORTTAB "${VMLINUX}"
299	if ! sorttable "${VMLINUX}"; then
300		echo >&2 Failed to sort kernel tables
301		exit 1
302	fi
303fi
304
305# step a (see comment above)
306if is_enabled CONFIG_KALLSYMS; then
307	if ! cmp -s System.map "${kallsyms_sysmap}"; then
308		echo >&2 Inconsistent kallsyms data
309		echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
310		exit 1
311	fi
312fi
313
314# For fixdep
315echo "${VMLINUX}: $0" > ".${VMLINUX}.d"
316